/**
 * Perforce Swarm
 *
 * @copyright   2013-2017 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level readme folder of this distribution.
 * @version     2017.2/1557039
 */

swarm.settings = {
    user: {
        init: function () {
            // Wire-up the reset btn to set all value back to default value being set in the input.
            $('#notificationReset').click(function () {
                $('#settings').find(':checkbox').each(function (i, item) {
                    if(!item.disabled) {
                        item.checked = $(this).data('default');
                    }
                });
                $('#checkAllNotifications')[0].checked = $('#notificationTable input:checked').length === $('#notificationTable input').length;
            });

            // check if all are set on load.
            $('#checkAllNotifications')[0].checked = $('#notificationTable input:checked').length === $('#notificationTable input').length;

            // Listen if the check all link is clicked and change all checkboxes to on or off.
            $('#checkAllNotifications').change(function () {
                $('#notificationTable input').each(function (item) {
                    if(!$('#notificationTable input')[item].disabled) {
                        $('#notificationTable input')[item].checked = $('#checkAllNotifications')[0].checked;
                    }
                });
            });

            // Check if all the input in the notificationform are set.
            $("#notificationForm input").change(function(){
                // Check if there are any disabled buttons and take them away from total as they
                var totalDisabled = $('#notificationTable input:disabled').length;
                // Check if the total checked element is equal or greater than the number of elements on the page,
                // taking away any disabled element.
                $('#checkAllNotifications')[0].checked = $('#notificationTable input:checked').length >= $('#notificationTable input').length - totalDisabled;


            });
            // If the page loads and user isn't on their settings buttons are all disabled.
            if ($('#notificationForm').hasClass('readOnly')) {
                var $settings = $('#settings');
                $settings.find(':checkbox').attr('disabled', true);
                $settings.find('.notificationSave').attr('disabled', true);
                $settings.find('#notificationReset').attr('disabled', true);
                $settings.find('#notificationCancel').attr('disabled', true);
            }
            // Set the token for the form.
            $('#token').attr('value', $('body').data('csrf'));
            // Disable the save button once the user has clicked once.
            $('#notificationForm button.notificationSave').submit(function () {
                    $('#notificationForm button.notificationSave').prop('disabled', true);
            });
        }
    }
};